#! /usr/bin/python
# coding: Utf-8

import os, sys, shutil, string, unicodedata, time, email.utils

target="microblog"
localpath="/var/www"
webpath="http://localhost"

# Ajoute le message au flux demandé.
def newitem(feed, message, extfile=None, guid=None):
    # Récupération d'un nom ASCII pour le flux.
    fname = ''.join(x for x in unicodedata.normalize('NFKD',
        feed.decode()) if x in string.ascii_letters).lower()
    
    # Vérification d'existence du flux demandé.
    fpath = os.path.join(localpath, target, fname+".rss")
    if os.path.exists(fpath): # Il existe, on ajoute.
        f = open(fpath, "r")
        content = f.read()
        f.close()
        # Récupération du contenu précédent…
        head,s,tail = content.partition("/>")
        head += s
    else: # Le flux n'existe pas, on va devoir le créer.
        if fname != "main": # On prévient sur le flux principal…
            newitem("main", "Nouveau sujet ["+feed+"]", fname+".rss", fname)
        head = """<?xml version="1.0" encoding="utf-8" ?>
<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
	<channel>
		<title>Microblog ("""+feed+""")</title>
		<description>Elzen's Microblog</description>
		<link>"""+webpath+"""</link>
		<atom:link href=\""""
        head += os.path.join(webpath, target, fname+".rss")
        head += """\" rel="self" type="application/rss+xml" />"""
        tail = """
	</channel>
</rss>"""
    
    # On formate les choses correctement…
    message = message.replace("&", "&amp;").replace("<", "&lt;")
    timestamp = email.utils.formatdate(time.time())
    if guid == None: guid = timestamp
    
    # Plus qu'à écrire ça.
    f = open(fpath, "w")
    f.write(head)
    f.write("""
		
		<item>
			<guid isPermaLink="false">"""+guid+"""</guid>
			<description>"""+message+"""</description>""")
    if extfile != None:
        if not extfile.startswith("http"):
            extfile = os.path.join(webpath, target, extfile)
        f.write("""
			<link>"""+extfile+"""</link>""")
    f.write("""
			<pubDate>"""+timestamp+"""</pubDate>
		</item>""")
    f.write(tail)
    f.close()

if __name__ == '__main__':
    # Vérification du nombre d'arguments.
    if len(sys.argv) not in range(2, 5):
        print "Usage :",sys.argv[0],"[sujet] message [fichier]"
        sys.exit(1)
    
    # Récupération des arguments…
    if len(sys.argv) == 2:
        message = sys.argv[1]
        extfile = None
        feed = "main"
    else:
        message = sys.argv[2]
        feed = sys.argv[1]
        if len(sys.argv) == 4:
            extfile = sys.argv[3]
        elif os.path.exists(message) or message.startswith("http"):
            extfile = message
            message = feed
            feed = "main"
        else:
            extfile = None
    
    # Vérification du fichier joint.
    if extfile != None and not extfile.startswith("http"):
        if not os.path.exists(extfile):
            print "Ce fichier n'existe pas."
            sys.exit(2)
        shutil.copy(extfile, os.path.join(localpath, target))
        extfile = os.path.split(extfile)[1]
    
    # Allez, écrivons tout ça.
    newitem(feed, message, extfile)
    if feed != "main": # Sur le sujet principal aussi…
        newitem("main", "["+feed+"] "+message, extfile)
    sys.exit(0)
